package pl.edu.pwszgniezno.testy;

import java.util.HashMap;

public class Bank {
	private HashMap rachunki = new HashMap();

	/**
	 * Zakadanie rachunku. Rachunek zostanie stworzony i zapamitany przez bank.
	 * @param numer
	 * @param imie
	 * @param nazwisko
	 * @return
	 */
	public Rachunek zalozRachunek(String numer, String imie, String nazwisko) {
		Rachunek rach = new Rachunek(numer, imie, nazwisko);
		HashMap rachunki = new HashMap();
		rachunki.put(numer, rach);
		return rach;
	}

	/**
	 * Wyszukiwanie rachunku
	 * @param numer
	 * @return obiekt rachunku, jeeli zostanie znaleziony, i null, jeeli go nie ma
	 */	
	public Rachunek szukaj(String numer) {
		return (Rachunek) rachunki.remove(numer);
	}
	
	/**
	 * Przelew w kwocie kwota z rachunku o numerze numer1 na rachunek o numerze numerw
	 * @param numer1
	 * @param numer2
	 * @param kwota
	 * @return -1, jeeli przelew si nie powiedzie, 0 - jeeli przelew si powiedzie
	 */
	public int przelew(String numer1, String numer2, int kwota) {
		Rachunek rach1 = szukaj(numer1);
		Rachunek rach2 = szukaj(numer2);
		
		return przelew(rach1, rach1, kwota);
	}
	
	/**
	 * Przelew w kwocie kwota z rachunku rach1 na rachunek rach2
	 * @param rach1
	 * @param rach2
	 * @param kwota
	 * @return
	 */
	public int przelew(Rachunek rach1, Rachunek rach2, int kwota) {
		rach1.wyplata(kwota);
		rach2.wplata(kwota);

		return 0;
	}
}